/******************************************************************************
XTalSelfCal

XTal self calibration with capacitor diode

(c) 2009 Dipl.-Ing. (FH) Rainer Reusch for Elektor
Homepage: http://elektor.reworld.eu

Environment: 	Atmel AVR Studio 4.16.638
Compiler:			GCC, WinAVR 20090313

Created: 2009-11-16
Changed: 2009-11-16
******************************************************************************/

#include <avr/io.h>

#define CLOCKOUT	PB0			// measure output: 0.05x XTal frequency
#define ADJUST		1				// analogue adjustment ADC input (1=ADC1) for demo
#define	PWMOUT		PB1			// pwm output for xtal frequency adjustment

//-----------------------------------------------------------------------------
int main(void)
//-----------------------------------------------------------------------------
{
	// init ports
	DDRB|=_BV(CLOCKOUT)|_BV(PWMOUT);		// set some ports as output
	// init pwm output
	TCCR1=_BV(PWM1A)|_BV(COM1A1)|_BV(COM1A0)|_BV(CS11)|_BV(CS10);
	// init ADC (free running mode)
	ADCSRA=_BV(ADEN);
	ADMUX=_BV(ADLAR)|ADJUST;
	DIDR0=_BV(ADC1D);
	ADCSRB&=0x40;
	ADCSRA=_BV(ADEN)|_BV(ADSC)|_BV(ADATE)|_BV(ADPS2)|_BV(ADPS1)|_BV(ADPS0);
	// main loop
  for(;;)
	{	
		OCR1A=ADCH;						// set calibration value (pulse width)
		PORTB^=_BV(CLOCKOUT);	// toggle clock output (0.05x fxtal)
		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("nop");
	}
  return 0;
}
